# unit-test-api
sample spec for testing openapi functionality, built from json schema tests for draft6

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.1
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonExperimentalClientCodegen

## Requirements.

Python &gt;&#x3D;3.9
v3.9 is needed so one can combine classmethod and property decorators to define
object schema properties as classes

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import unit_test_api
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import unit_test_api
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import unit_test_api
from pprint import pprint
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------

## Documentation For Models

 - [AdditionalpropertiesAllowsASchemaWhichShouldValidate](docs/AdditionalpropertiesAllowsASchemaWhichShouldValidate.md)
 - [AdditionalpropertiesAreAllowedByDefault](docs/AdditionalpropertiesAreAllowedByDefault.md)
 - [AdditionalpropertiesCanExistByItself](docs/AdditionalpropertiesCanExistByItself.md)
 - [AdditionalpropertiesShouldNotLookInApplicators](docs/AdditionalpropertiesShouldNotLookInApplicators.md)
 - [ArrayTypeMatchesArrays](docs/ArrayTypeMatchesArrays.md)
 - [BooleanTypeMatchesBooleans](docs/BooleanTypeMatchesBooleans.md)
 - [ByInt](docs/ByInt.md)
 - [ByNumber](docs/ByNumber.md)
 - [BySmallNumber](docs/BySmallNumber.md)
 - [DateTimeFormat](docs/DateTimeFormat.md)
 - [EmailFormat](docs/EmailFormat.md)
 - [EnumWith0DoesNotMatchFalse](docs/EnumWith0DoesNotMatchFalse.md)
 - [EnumWith1DoesNotMatchTrue](docs/EnumWith1DoesNotMatchTrue.md)
 - [EnumWithEscapedCharacters](docs/EnumWithEscapedCharacters.md)
 - [EnumWithFalseDoesNotMatch0](docs/EnumWithFalseDoesNotMatch0.md)
 - [EnumWithTrueDoesNotMatch1](docs/EnumWithTrueDoesNotMatch1.md)
 - [EnumsInProperties](docs/EnumsInProperties.md)
 - [ForbiddenProperty](docs/ForbiddenProperty.md)
 - [HostnameFormat](docs/HostnameFormat.md)
 - [IntegerTypeMatchesIntegers](docs/IntegerTypeMatchesIntegers.md)
 - [InvalidInstanceShouldNotRaiseErrorWhenFloatDivisionInf](docs/InvalidInstanceShouldNotRaiseErrorWhenFloatDivisionInf.md)
 - [InvalidStringValueForDefault](docs/InvalidStringValueForDefault.md)
 - [Ipv4Format](docs/Ipv4Format.md)
 - [Ipv6Format](docs/Ipv6Format.md)
 - [JsonPointerFormat](docs/JsonPointerFormat.md)
 - [MaximumValidation](docs/MaximumValidation.md)
 - [MaximumValidationWithUnsignedInteger](docs/MaximumValidationWithUnsignedInteger.md)
 - [MaxitemsValidation](docs/MaxitemsValidation.md)
 - [MaxlengthValidation](docs/MaxlengthValidation.md)
 - [Maxproperties0MeansTheObjectIsEmpty](docs/Maxproperties0MeansTheObjectIsEmpty.md)
 - [MaxpropertiesValidation](docs/MaxpropertiesValidation.md)
 - [MinimumValidation](docs/MinimumValidation.md)
 - [MinimumValidationWithSignedInteger](docs/MinimumValidationWithSignedInteger.md)
 - [MinitemsValidation](docs/MinitemsValidation.md)
 - [MinlengthValidation](docs/MinlengthValidation.md)
 - [MinpropertiesValidation](docs/MinpropertiesValidation.md)
 - [ModelNot](docs/ModelNot.md)
 - [NestedItems](docs/NestedItems.md)
 - [NotMoreComplexSchema](docs/NotMoreComplexSchema.md)
 - [NulCharactersInStrings](docs/NulCharactersInStrings.md)
 - [NullTypeMatchesOnlyTheNullObject](docs/NullTypeMatchesOnlyTheNullObject.md)
 - [NumberTypeMatchesNumbers](docs/NumberTypeMatchesNumbers.md)
 - [ObjectPropertiesValidation](docs/ObjectPropertiesValidation.md)
 - [PatternIsNotAnchored](docs/PatternIsNotAnchored.md)
 - [PatternValidation](docs/PatternValidation.md)
 - [PropertiesWithEscapedCharacters](docs/PropertiesWithEscapedCharacters.md)
 - [PropertyNamedRefThatIsNotAReference](docs/PropertyNamedRefThatIsNotAReference.md)
 - [RefInAdditionalproperties](docs/RefInAdditionalproperties.md)
 - [RefInAllof](docs/RefInAllof.md)
 - [RefInAnyof](docs/RefInAnyof.md)
 - [RefInItems](docs/RefInItems.md)
 - [RefInOneof](docs/RefInOneof.md)
 - [RefInProperty](docs/RefInProperty.md)
 - [RequiredDefaultValidation](docs/RequiredDefaultValidation.md)
 - [RequiredValidation](docs/RequiredValidation.md)
 - [RequiredWithEmptyArray](docs/RequiredWithEmptyArray.md)
 - [SimpleEnumValidation](docs/SimpleEnumValidation.md)
 - [StringTypeMatchesStrings](docs/StringTypeMatchesStrings.md)
 - [TheDefaultKeywordDoesNotDoAnythingIfThePropertyIsMissing](docs/TheDefaultKeywordDoesNotDoAnythingIfThePropertyIsMissing.md)
 - [UniqueitemsFalseValidation](docs/UniqueitemsFalseValidation.md)
 - [UniqueitemsValidation](docs/UniqueitemsValidation.md)
 - [UriFormat](docs/UriFormat.md)
 - [UriReferenceFormat](docs/UriReferenceFormat.md)
 - [UriTemplateFormat](docs/UriTemplateFormat.md)

## Documentation For Authorization

 All endpoints do not require authorization.

## Author


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in unit_test_api.apis and unit_test_api.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from unit_test_api.api.default_api import DefaultApi`
- `from unit_test_api.model.pet import Pet`

Solution 1:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import unit_test_api
from unit_test_api.apis import *
from unit_test_api.models import *
```
